package Abstract1;

abstract class Superclass
{
    // gemeinsame Methoden, die nicht berschrieben werden knnen
    public final void f()
    {
        System.out.println("Superclass:Finale Methode f()") ;
    }

    // Methode, welche berschrieben werden knnen
    // Aber es steht eine Default Implementation zur Verfgung
    public void common()
    {
        System.out.println("Superclass:Methode Common()") ;
    }

    protected int i = 10 ;
    protected int j = 20 ;
}

class Subclass extends Superclass
{
    public void test()
    {
        // Aufruf einer Superklassen Methode
        f() ;
        // Zugriff auf ein Datenfeld der Oberklasse
        i = 20 ;
    }
}

class Subclass2 extends Superclass
{
    public void common()
    {
        System.out.println("Subclass2:Methode common()") ;
    }
}

class Abstract1
{
    public static void main(String[] args)
    {
        // ein Superklasse Objekt kann man nicht konstruieren
        // Superclass superclass = new Superclass() ; // Error

        Subclass subclass = new Subclass() ;
        subclass.test() ;

        // eine Unterklasse kann an Stelle einer Oberklasse verewendet werden
        Superclass superclass = subclass ;
        superclass.common() ;
        // jetzt berschreiben wir die Instanz der Oberklasse
        superclass = new Subclass2() ;
        superclass.common() ;

        // die Methode f() steht auch hier zur Verfgung
        subclass.f() ;
        superclass.f() ;
    }
}
