package Abstract2;

abstract class Superclass
{
    // abstrakte Methode
    public abstract void f() ;

    // Standard method - kann berschrieben werden
    public void h()
    {
        System.out.println("Superclass: Methode h()") ;
    }

    // abstract static Methoden gibt es nicht
    // public abstract static void x() ; // Error
}

class Subclass extends Superclass
{
    // berschreiben der Methode f() aus der Oberklasse
    public void f()
    {
        System.out.println("Subclass : Methode f()") ;
    }
}

// abstrakte Unterklasse einer abstrakten Klasse
abstract class Subclass2 extends Superclass
{
    // neue abstrakte Methode
    public abstract void g() ;

}

// Implementation der abstrakten Unterklasse 2
//      diese muss alle Methoden implementieren
class Subclass3 extends Subclass2
{
    // berschreiben der vordefinierten Methoden
    public void f()
    {
        System.out.println("Subclass2 : Methode f()") ;
    }

    // berschreiben der vordefinierten Methoden
    public void g()
    {
        System.out.println("Subclass2 : Methode g()") ;
    }

    // berschreiben der vordefinierten Methoden
    // muss diese Methode berhaupt implementiert werden? NEIN!
    public void h()
    {
        System.out.println("Superclass : Methode h()") ;
    }
}

class Abstract2
{
    public static void main(String[] args)
    {
        // das geht nicht
        // Superclass superclass = new Superclass(); // Error abstract

        // das geht nicht
        // Subclass subclass2 = new Subclass2() ; // Error abstract

        Subclass subclass = new Subclass() ;
        subclass.f() ;
        subclass.h() ;

        Subclass3 subclass3 = new Subclass3() ;
        subclass3.f() ;
        subclass3.g() ;
        subclass3.h() ;
    }
}
