package basisdatentypinteger;

/**
 * Title:        Basistyp Integer
 * Description:
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class IntegerBasisdatentyp {
  public static void main(String[] args) {
    byte num8=-1;   //-128 ... 127
    short num16=-1; //-32768 ... 32767
    int num32=-1;   //-2147483648 ... 2147483647
    long num64=-1;  //-9223372036854775808 ... 9223372036854775807
    /**
     * Zu jedem Basisdatentyp existiert eine sogenannte Wrapperklasse,
     * eine Java Klasse mit dem selben Namen (gross geschrieben: Klasse)
     * damit Sie auch die Basisdatentypen als Objekte behandeln knnen!
     */
     System.out.println("Maximale Werte der 'Integer' Basisdatentypen");
     System.out.println("Byte    (num8)   : von "+Byte.MIN_VALUE+" bis "+Byte.MAX_VALUE);
     System.out.println("Short   (num16)  : von "+Short.MIN_VALUE+" bis "+Short.MAX_VALUE);
     System.out.println("Integer (num32)  : von "+Integer.MIN_VALUE+" bis "+Integer.MAX_VALUE);
     System.out.println("Long    (num64)  : von "+Long.MIN_VALUE+" bis "+Long.MAX_VALUE);
    /**
     * Das Beispiel zeigt, dass bei der Byte (num8) Darstellung
     * die Gefahr besteht, dass man durch Addition einer Zahl
     * den Definitionsbereich von byte verlsst und unerwartete
     * Ergebnisse erzielen knnte!
     */
    System.out.println("Byte");
    for (int i=0;i<260; i++) {
      System.out.println("Byte Integer : "+num8++ +"  Bitdarstellung: "+Integer.toBinaryString(num8));
    }
    /**
     * nun die selbe bung mit short (num16)
     */
    System.out.println("Short");
    num16 = 32760;
    for (int i=0;i<10; i++) {
      System.out.println("Short Integer : "+num16++ +"  Bitdarstellung: "+Integer.toBinaryString(num16));
    }
    /**
     * nun die selbe bung mit int (num32)
     */
    System.out.println("Integer");
    num32 = 2147483640;
    for (int i=0; i<10; i++) {
      System.out.println("Integer Integer : "+num32++ +"  Bitdarstellung: "+Integer.toBinaryString(num32));
    }
    /**
     * nun die selbe bung mit int (num64)
     */
    System.out.println("Long");
    num64=(long)(Long.MAX_VALUE-5);
    for (int i=0; i<10; i++) {
      System.out.println("Long Integer : "+num64++ +"  Bitdarstellung: "+Long.toBinaryString(num64));
    }
  }
}