package Sieve;

// Class to represent a filter object.
class PrimeFilter
{
    // Initializer new filter to hold given
    // prime number.
    public PrimeFilter(final int i)
    {
        prime = i ;
        System.out.println(prime + " ist Primzahl") ;
    }

    // Process the argument to see if it is
    // divisible by the prime held by the current
    // object. If it is then it can be rejected,
    // otherwise it is passed on, creating a new
    // filter if necessary.
    public void process(final int i)
    {
        if ((i % prime) != 0)
        {
            if (next != null)
            {
                next.process(i) ;
            }
            else
            {
                next = new PrimeFilter(i) ;
            }
        }
    }

    private int prime ; // Prime number held by filter
                        // object
    PrimeFilter next ;  // Reference to next filter
                        // object in the chain.
}

public class Sieve
{
    public static void main(String[] args)
    {
        PrimeFilter two = new PrimeFilter(2) ;
        for (int i = 3 ; i < 10000 ; i += 2)
        {
            two.process(i) ;
        }
    }
}
