package SimpleQueue;
// Dokumentation gemss Java Standard
/**
 *  A <code>SimpleQueue</code> of <code>Object</code>s.  The
 *  implementation uses a circular array, i.e. an array of a given
 *  size with indexes that wrap around as needed.
 */
class SimpleQueue
{
    //
    //  The public methods.
    //

    /**
     *  Add an element to the <code>SimpleQueue</code>.
     */
    public void addback(Object x) throws QueueException
    {
        if (count >= queueSize)
        {
            throw new QueueException("Warteschlange ist voll") ;
        }
        count++ ;
        items[rear] = x ;
        rear = (rear + 1) % queueSize ;
    }

    /**
     *   Remove an element from the <code>SimpleQueue</code>.
     */
    public Object removefront() throws QueueException
    {
        if (count <= 0)
        {
            throw new QueueException("Warteschlange ist leer");
        }
        Object temp = items[front] ;
        front = (front + 1) % queueSize ;
        return temp ;
    }

    //
    //  The private data.
    //

    /**
     *  The maximum size of the <code>SimpleQueue</code>.  This is an
     *  internal constant, hence it is private.  It is a constant so
     *  it is final.
     */
    private final static int queueSize = 10 ;

    /**
     *  The index into the array of the front element in the
     *  <code>SimpleQueue</code>.  Take from here.
     */
    private int front = 0 ;

    /**
     *  The index into the array of the rear element in the
     *  <code>SimpleQueue</code>.  Add to here.
     */
    private int rear = 0 ;

    /**
     *  The count of the number of items currently in the
     *  <code>SimpleQueue</code>.
     */
    private int count = 0 ;

    /**
     *  The array in which all the items in the
     *  <code>SimpleQueue</code> are held.
     */
    private Object[] items = new Object[queueSize] ;
}
