package ThreadTest6;

class ThreadTest6
{
    // Declare a set of member classes to create
    // threads calling different test methods
    // with different pauses.
    class MyThread1 extends Thread
    {
        public void run()
        {
            for (int i = 0 ; i < 10 ; i++)
            {
                g() ;
            }
        }
    }

    class MyThread2 extends Thread
    {
        public void run()
        {
            setPriority(8) ;
            for (int i = 0 ; i < 10 ; i++)
            {
                g() ;
                pause(700) ;
            }
        }
    }

    class MyThread3 extends Thread
    {
        public void run()
        {
            for (int i = 0 ; i < 100 ; i++)
            {
                f(500) ;
            }
        }
    }

    class MyThread4 extends Thread
    {
        public void run()
        {
            setPriority(8) ;
            for (int i = 0 ; i < 150 ; i++)
            {
                f(100) ;
                pause(200) ;
            }
        }
    }

    // Package up call to sleep in an easier
    // to use method.
    public void pause(int n)
    {
        // Pause for a semi-random time
        int r = (int)(Math.random() * n) ;
        try
        {
            Thread.currentThread().sleep(r) ;
        }
        catch (InterruptedException e)
        {}
    }

    // Unsynchronized method. Threads can be
    // interleaved when running this.
    public void f(int p)
    {
        i++ ;

        pause(p) ;

        j++ ;
        System.out.println("Methode f: "
                            + ((i==j)? "gleich" : "unterschiedlich")) ;
    }

    // Threads cannot be interleaved when executing
    // this method.
    public synchronized void g()
    {
        i++ ;
        j++ ;
        System.out.println("Method g: "
                            + ((i==j)? "gleich" : "unterschiedlich")) ;
    }

    // Run the tests
    public void go()
    {
        // Call the synchronized method and note that
        // the variables i and j never diverge.
        System.out.println("Aufruf von Methode g") ;
        Thread t1 = new MyThread1() ;
        Thread t2 = new MyThread2() ;
        i = 0 ;
        j = 0 ;
        t1.start() ;
        t2.start() ;
        try
        {
            t1.join() ;
            t2.join() ;
        }
        catch (InterruptedException e)
        {}

        // Call the unsynchronized method and note that
        // i and j can diverge.
        System.out.println("Aufruf von Methode f") ;
        t1 = new MyThread3() ;
        t2 = new MyThread4() ;
        i = 0 ;
        j = 0 ;
        t1.start() ;
        t2.start() ;
    }

    public static void main(String[] args)
    {
        ThreadTest6 shared = new ThreadTest6() ;
        shared.go() ;
    }

    private int i = 0 ;
    private int j = 0 ;
}
